!     INTEGER FUNCTION IDAMAX(N,DX,INCX)
      integer function iddamax(n,dxh,dxl,incx)
      implicit none
*     .. Scalar Arguments ..
      INTEGER INCX,N
*     ..
*     .. Array Arguments ..
!     DOUBLE PRECISION DX(*)
      double precision dxh(*), dxl(*)
      double precision ddxh, ddxl
      double precision absdxh, absdxl
      double precision dmaxh, dmaxl
!     tmp vars
      double precision t_ch, t_cl
      double precision t_p1, t_p2
      double precision t_q1, t_q2
      double precision t_r1, t_r2
      double precision t_s1, t_s2
      double precision t_t1, t_t2
      double precision t_u1, t_u2
      double precision t_x1, t_x2
      double precision t_y1, t_y2
      double precision t_z1, t_z2
      double precision t_x, t_ax
      double precision t_t1h, t_t1l
      double precision t_t2h, t_t2l
#ifdef FPCOUNTER
#include "fpcounter.h"
#endif
*     ..
*
*  Purpose
*  =======
*
*     finds the index of element having max. absolute value.
*     jack dongarra, linpack, 3/11/78.
*     modified 3/93 to return if incx .le. 0.
*     modified 12/3/93, array(1) declarations changed to array(*)
*
*
!     double double modefication (f.y.)
*     .. Local Scalars ..
!     DOUBLE PRECISION DMAX
      INTEGER I,IX
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC DABS
#ifdef FPCOUNTER
#include "finit.h"
      SUBNAME = "iddamax"
#endif
*     ..
!     IDAMAX = 0
      iddamax = 0
!     IF (N.LT.1 .OR. INCX.LE.0) RETURN
      IF (N.LT.1 .OR. INCX.LE.0) goto 9999
!     IDAMAX = 1
      iddamax = 1
!     IF (N.EQ.1) RETURN
      IF (N.EQ.1) goto 9999
      IF (INCX.EQ.1) GO TO 20
*
*        code for increment not equal to 1
*
      IX = 1
!     DMAX = DABS(DX(1))
!<<<  dmax = abs(dx(1))
      if (dxh(1) .lt. 0.0d+0) then
        dmaxh = -dxh(1)
        dmaxl = -dxl(1)
      elseif (
     +  (dxh(1) .eq. 0.0d+0).and.
     +  (dxl(1) .lt. 0.0d+0)) then
        dmaxh = dxh(1)
        dmaxl = -dxl(1)
      else
        dmaxh = dxh(1)
        dmaxl = dxl(1)
      endif
!>>>  dmax = abs(dx(1))
      IX = IX + INCX
      DO 10 I = 2,N
!<<<      absdx = abs(dx(ix))
          if (dxh(ix) .lt. 0.0d+0) then
            absdxh = -dxh(ix)
            absdxl = -dxl(ix)
          elseif (
     +      (dxh(ix) .eq. 0.0d+0).and.
     +      (dxl(ix) .lt. 0.0d+0)) then
            absdxh = dxh(ix)
            absdxl = -dxl(ix)
          else
            absdxh = dxh(ix)
            absdxl = dxl(ix)
          endif
!>>>      absdx = abs(dx(ix))
!         IF (DABS(DX(IX)).LE.DMAX) GO TO 5
          if(
!           (absdx .le. dmax)
     +     ((absdxh .lt. dmaxh) .or.
     +      ((absdxh .eq. dmaxh) .and.
     +       (absdxl .le. dmaxl)))
     +    ) goto 5
!         IDAMAX = I
          iddamax = I
!         DMAX = DABS(DX(IX))
!<<<      dmax = abs(dx(ix))
          if (dxh(ix) .lt. 0.0d+0) then
            dmaxh = -dxh(ix)
            dmaxl = -dxl(ix)
          elseif (
     +      (dxh(ix) .eq. 0.0d+0).and.
     +      (dxl(ix) .lt. 0.0d+0)) then
            dmaxh = dxh(ix)
            dmaxl = -dxl(ix)
          else
            dmaxh = dxh(ix)
            dmaxl = dxl(ix)
          endif
!>>>      dmax = abs(dx(ix))
    5     IX = IX + INCX
   10 CONTINUE
      goto 9999
!     RETURN
*
*        code for increment equal to 1
*
   20 continue
!  20 DMAX = DABS(DX(1))
!<<<  dmax = abs(dx(1))
      if (dxh(1) .lt. 0.0d+0) then
        dmaxh = -dxh(1)
        dmaxl = -dxl(1)
      elseif (
     +  (dxh(1) .eq. 0.0d+0).and.
     +  (dxl(1) .lt. 0.0d+0)) then
        dmaxh = dxh(1)
        dmaxl = -dxl(1)
      else
        dmaxh = dxh(1)
        dmaxl = dxl(1)
      endif
!>>>  dmax = abs(dx(1))
      DO 30 I = 2,N
!         IF (DABS(DX(I)).LE.DMAX) GO TO 30
!<<<      absdx = abs(dx(i))
          if (dxh(i) .lt. 0.0d+0) then
            absdxh = -dxh(i)
            absdxl = -dxl(i)
          elseif (
     +      (dxh(i) .eq. 0.0d+0).and.
     +      (dxl(i) .lt. 0.0d+0)) then
            absdxh = dxh(i)
            absdxl = -dxl(i)
          else
            absdxh = dxh(i)
            absdxl = dxl(i)
          endif
!>>>      absdx = abs(dx(i))
          if(
!           (absdx .le. dmax)
     +     ((absdxh .lt. dmaxh) .or.
     +      ((absdxh .eq. dmaxh) .and.
     +       (absdxl .le. dmaxl)))
     +    ) goto 30
!         IDAMAX = I
          iddamax = I
!         DMAX = DABS(DX(I))
!<<<      dmax = abs(dx(i))
          if (dxh(i) .lt. 0.0d+0) then
            dmaxh = -dxh(i)
            dmaxl = -dxl(i)
          elseif (
     +      (dxh(i) .eq. 0.0d+0).and.
     +      (dxl(i) .lt. 0.0d+0)) then
            dmaxh = dxh(i)
            dmaxl = -dxl(i)
          else
            dmaxh = dxh(i)
            dmaxl = dxl(i)
          endif
!>>>      dmax = abs(dx(i))
   30 CONTINUE
 9999 continue
#ifdef FPCOUNTER
      WRITE(6,1000) "MODULE    = iddamax"
#include "fout.h"
#include "fformat.h"
#endif
      RETURN
      END
