!     DOUBLE COMPLEX FUNCTION ZDOTU(N,ZX,INCX,ZY,INCY)
      subroutine zzdotu(n, zxh, zxl, incx, zyh, zyl, incy, zzh, zzl)
      use bailey
      implicit none
*     .. Scalar Arguments ..
      INTEGER INCX,INCY,N
*     ..
*     .. Array Arguments ..
!     DOUBLE COMPLEX ZX(*),ZY(*)
      double complex zxh(*), zxl(*)
      double complex zyh(*), zyl(*)
*     ..
*
*  Purpose
*  =======
*
*     ZDOTU forms the dot product of two vectors.
*
*  Further Details
*  ===============
*
*     jack dongarra, 3/11/78.
*     modified 12/3/93, array(1) declarations changed to array(*)
*
!  zzh, zzl: output
!
!  double double modefication (f.y.)
*     .. Local Scalars ..
!     DOUBLE COMPLEX ZTEMP
      double complex ztemph, ztempl
      double complex ddmxh, ddmxl
      double complex ddaxh, ddaxl
      double complex zzh, zzl
!     tmp vars
      double complex x_ch, x_cl
      double complex x_p1, x_p2
      double complex x_q1, x_q2
      double complex x_r1, x_r2
      double complex x_s1, x_s2
      double complex x_t1, x_t2
      double complex x_u1, x_u2
      double complex x_x1, x_x2
      double complex x_y1, x_y2
      double complex x_z1, x_z2
      double complex x_x, x_ax
      double complex x_t1h, x_t1l
      double complex x_t2h, x_t2l
      INTEGER I,IX,IY
      integer ix0,iy0
#ifdef FPCOUNTER
#include "fpcounter.h"
#endif
#ifdef FPCOUNTER
#include "finit.h"
      SUBNAME = "zzdotu"
#endif
*     ..
!     ZTEMP = (0.0d0,0.0d0)
!     ZDOTU = (0.0d0,0.0d0)
      ztemph = (0.0d0,0.0d0)
      ztempl = (0.0d0,0.0d0)
      zzh = (0.0d0,0.0d0)
      zzl = (0.0d0,0.0d0)
!     IF (N.LE.0) RETURN
      IF (N.LE.0) goto 9999
      IF (INCX.EQ.1 .AND. INCY.EQ.1) GO TO 20
*
*        code for unequal increments or equal increments
*          not equal to 1
*
      IX = 1
      IY = 1
      IF (INCX.LT.0) IX = (-N+1)*INCX + 1
      IF (INCY.LT.0) IY = (-N+1)*INCY + 1
      ix0 = ix
      iy0 = iy
!$omp parallel
!$omp do
!$omp+ private(I,ix,iy)
!     tmp vars -> private
!$omp+ private(x_ch, x_cl)
!$omp+ private(x_p1, x_p2)
!$omp+ private(x_q1, x_q2)
!$omp+ private(x_r1, x_r2)
!$omp+ private(x_s1, x_s2)
!$omp+ private(x_t1, x_t2)
!$omp+ private(x_u1, x_u2)
!$omp+ private(x_x1, x_x2)
!$omp+ private(x_y1, x_y2)
!$omp+ private(x_z1, x_z2)
!$omp+ private(x_x, x_ax)
!$omp+ private(x_t1h, x_t1l)
!$omp+ private(x_t2h, x_t2l)
!$omp+ private(ddmxh, ddmxl)
      DO 10 I = 1,N
          ix = ix0 + (i - 1)*incx
          iy = iy0 + (i - 1)*incy
!         ZTEMP = ZTEMP + ZX(IX)*ZY(IY)
!<<<      ddmx = zx(ix) * zy(iy)
          call bmul( zxh(ix), zxl(ix), zyh(iy), zyl(iy), ddmxh, ddmxl )
!          ddmxh = zxh(ix) * zyh(iy)
!          x_u1 = 134217729.0 * zxh(ix)
!          x_p1 = x_u1
!     +             - (x_u1 - zxh(ix))
!          x_p2 = zxh(ix) - x_p1
!          x_u1 = 134217729.0 * zyh(iy)
!          x_r1 = x_u1
!     +             - (x_u1 - zyh(iy))
!          x_r2 = zyh(iy) - x_r1
!          ddmxl = ((x_p1*x_r1
!     +            - ddmxh)
!     +            + x_p1 * x_r2
!     +            + x_p2 * x_r1)
!     +            + x_p2 * x_r2
!          ddmxl = ddmxl
!     +          + (zxh(ix)*zyl(iy)
!    +          + zxl(ix)*zyh(iy))
!          x_s1 = ddmxh + ddmxl
!          ddmxl = ddmxl - (x_s1 - ddmxh)
!          ddmxh = x_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>      ddmx = zx(ix) * zy(iy)
!$omp critical
!<<<      ztemp = ztemp + ddmx
          call bsum( ztemph, ztempl, ddmxh, ddmxl, ztemph, ztempl )
!          x_p1 = ztemph + ddmxh
!          x_p2 = x_p1 - ztemph
!          x_q1 = x_p1
!          x_q2 = (ztemph - (x_p1 - x_p2))
!     +             + (ddmxh - x_p2)
!          x_q2 = x_q2 + ztempl + ddmxl
!          ztemph = x_q1 + x_q2
!          ztempl = x_q2 - (ztemph - x_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>      ztemp = ztemp + ddmx
!$omp end critical
!!        IX = IX + INCX
!!        IY = IY + INCY
   10 CONTINUE
!$omp end do
!$omp end parallel
!     ZDOTU = ZTEMP
      zzh = ztemph
      zzl = ztempl
      goto 9999
      RETURN
*
*        code for both increments equal to 1
*
   20 continue
!! 20 DO 30 I = 1,N
!$omp parallel
!$omp do
!$omp+ private(I)
!     tmp vars -> private
!$omp+ private(x_ch, x_cl)
!$omp+ private(x_p1, x_p2)
!$omp+ private(x_q1, x_q2)
!$omp+ private(x_r1, x_r2)
!$omp+ private(x_s1, x_s2)
!$omp+ private(x_t1, x_t2)
!$omp+ private(x_u1, x_u2)
!$omp+ private(x_x1, x_x2)
!$omp+ private(x_y1, x_y2)
!$omp+ private(x_z1, x_z2)
!$omp+ private(x_x, x_ax)
!$omp+ private(x_t1h, x_t1l)
!$omp+ private(x_t2h, x_t2l)
!$omp+ private(ddmxh, ddmxl)
      DO 30 I = 1,N
!         ZTEMP = ZTEMP + ZX(I)*ZY(I)
!<<<      ddmx = zx(i) * zy(i)
          call bmul( zxh(i), zxl(i), zyh(i), zyl(i), ddmxh, ddmxl )
!          ddmxh = zxh(i) * zyh(i)
!          x_u1 = 134217729.0 * zxh(i)
!          x_p1 = x_u1
!     +             - (x_u1 - zxh(i))
!          x_p2 = zxh(i) - x_p1
!          x_u1 = 134217729.0 * zyh(i)
!          x_r1 = x_u1
!     +             - (x_u1 - zyh(i))
!          x_r2 = zyh(i) - x_r1
!          ddmxl = ((x_p1*x_r1
!     +            - ddmxh)
!     +            + x_p1 * x_r2
!     +            + x_p2 * x_r1)
!     +            + x_p2 * x_r2
!          ddmxl = ddmxl
!     +          + (zxh(i)*zyl(i)
!     +          + zxl(i)*zyh(i))
!          x_s1 = ddmxh + ddmxl
!          ddmxl = ddmxl - (x_s1 - ddmxh)
!          ddmxh = x_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>      ddmx = zx(i) * zy(i)
!$omp critical
!<<<      ztemp = ztemp + ddmx
          call bsum( ztemph, ztempl, ddmxh, ddmxl, ztemph, ztempl )
!          x_p1 = ztemph + ddmxh
!          x_p2 = x_p1 - ztemph
!          x_q1 = x_p1
!          x_q2 = (ztemph - (x_p1 - x_p2))
!     +             + (ddmxh - x_p2)
!          x_q2 = x_q2 + ztempl + ddmxl
!          ztemph = x_q1 + x_q2
!          ztempl = x_q2 - (ztemph - x_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>      ztemp = ztemp + ddmx
!$omp end critical
   30 CONTINUE
!$omp end do
!$omp end parallel
!     ZDOTU = ZTEMP
      zzh = ztemph
      zzl = ztempl
 9999 continue
#ifdef FPCOUNTER
      WRITE(6,1000) "MODULE    = zzdotu"
#include "fout2.h"
#include "fformat.h"
#endif
      RETURN
      END
