      REAL(KIND(0Q0)) FUNCTION qasum(N,DX,INCX)
*     .. Scalar Arguments ..
      INTEGER INCX,N
*     ..
*     .. Array Arguments ..
      REAL(KIND(0Q0)) DX(*)
*     ..
*
*  Purpose
*  =======
*
*     qasum takes the sum of the absolute values.
*
*  Further Details
*  ===============
*
*     jack dongarra, linpack, 3/11/78.
*     modified 3/93 to return if incx .le. 0.
*     modified 12/3/93, array(1) declarations changed to array(*)
*
*  =====================================================================
*
*     .. Local Scalars ..
      REAL(KIND(0Q0)) DTEMP
      INTEGER I,M,MP1,NINCX
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC ABS,MOD
*     ..
      qasum = 0.0q0
      DTEMP = 0.0q0
      IF (N.LE.0 .OR. INCX.LE.0) RETURN
      IF (INCX.EQ.1) THEN
*        code for increment equal to 1
*
*
*        clean-up loop
*
         M = MOD(N,6)
         IF (M.NE.0) THEN
            DO I = 1,M
               DTEMP = DTEMP + ABS(DX(I))
            END DO
            IF (N.LT.6) THEN
               qasum = DTEMP
               RETURN
            END IF
         END IF
         MP1 = M + 1
         DO I = MP1,N,6
            DTEMP = DTEMP + ABS(DX(I)) + ABS(DX(I+1)) +
     $              ABS(DX(I+2)) + ABS(DX(I+3)) +
     $              ABS(DX(I+4)) + ABS(DX(I+5))
         END DO
      ELSE
*
*        code for increment not equal to 1
*
         NINCX = N*INCX
         DO I = 1,NINCX,INCX
            DTEMP = DTEMP + ABS(DX(I))
         END DO
      END IF
      qasum = DTEMP
      RETURN
      END
