      SUBROUTINE qrotg(DA,DB,C,S)
*     .. Scalar Arguments ..
      REAL(KIND(0Q0)) C,DA,DB,S
*     ..
*
*  Purpose
*  =======
*
*     qrotg construct givens plane rotation.
*
*  Further Details
*  ===============
*
*     jack dongarra, linpack, 3/11/78.
*
*  =====================================================================
*
*     .. Local Scalars ..
      REAL(KIND(0Q0)) R,ROE,SCALE,Z
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC ABS,SIGN,SQRT
*     ..
      ROE = DB
      IF (ABS(DA).GT.ABS(DB)) ROE = DA
      SCALE = ABS(DA) + ABS(DB)
      IF (SCALE.EQ.0.0q0) THEN
         C = 1.0q0
         S = 0.0q0
         R = 0.0q0
         Z = 0.0q0
      ELSE
         R = SCALE*SQRT((DA/SCALE)**2+ (DB/SCALE)**2)
         R = SIGN(1.0q0,ROE)*R
         C = DA/R
         S = DB/R
         Z = 1.0q0
         IF (ABS(DA).GT.ABS(DB)) Z = S
         IF (ABS(DB).GE.ABS(DA) .AND. C.NE.0.0q0) Z = 1.0q0/C
      END IF
      DA = R
      DB = Z
      RETURN
      END
