#!/usr/bin/env perl

use strict;
use warnings;

use Test::More;

require 't/common.pl';

my @dimensions = Test::QPBLAS::supply_default_dimensions();
my @increments = Test::QPBLAS::supply_default_increments();

plan tests => 8 * @dimensions * @increments * @increments + 4 * @dimensions * @increments + 2;
for my $n (@dimensions) {
  for my $incx (@increments) {
    for my $incy (@increments) {
      my %condition = (
        n => $n,
        incx => $incx,
        incy => $incy,
      );
      Test::QPBLAS::run(SWAP => \%condition);
      Test::QPBLAS::run(COPY => \%condition);
      Test::QPBLAS::run(AXPY => \%condition);
      Test::QPBLAS::run(DOT => \%condition);
      Test::QPBLAS::run(ROT => \%condition);
      Test::QPBLAS::run(ROTM => \%condition);
      Test::QPBLAS::run(DOTC => \%condition);
      Test::QPBLAS::run(DOTU => \%condition);
    }
  }
}

for my $n (@dimensions) {
  for my $incx (@increments) {
    my %condition = (
      n => $n,
      incx => $incx,
    );
      Test::QPBLAS::run(SCAL => \%condition);
      Test::QPBLAS::run(NRM2 => \%condition);
      Test::QPBLAS::run(ASUM => \%condition);
      Test::QPBLAS::run(AMAX => \%condition);
  }
}

Test::QPBLAS::run(ROTG => {});
Test::QPBLAS::run(ROTMG => {});
