use strict;
use warnings;

use List::Util qw(min);
use Test::More;

require 't/common.pl';

my @trans = Test::QPBLAS::supply_default_trans();
my @dimensions = Test::QPBLAS::supply_default_dimensions();
my @alphabeta = Test::QPBLAS::supply_default_alphabeta();
my @increments = Test::QPBLAS::supply_default_increments();

plan tests => @trans * @dimensions * @dimensions * @alphabeta * @increments * @alphabeta * @increments * 2;

for my $trans (@trans) {
  for my $m (@dimensions) {
    for my $n (@dimensions) {
      for my $alpha (@alphabeta) {
        for my $incx (@increments) {
          for my $beta (@alphabeta) {
            for my $incy (@increments) {
              my %condition = (
                trans => $trans,
                m => $m,
                n => $n,
                alpha => $alpha,
                incx => $incx,
                beta => $beta,
                incy => $incy,
              );
              Test::QPBLAS::run(GEMV => \%condition);
            }
          }
        }
      }
    }
  }
}

for my $trans (@trans) {
  for my $m (@dimensions) {
    for my $n (@dimensions) {
      for my $alpha (@alphabeta) {
        for my $incx (@increments) {
          for my $beta (@alphabeta) {
            for my $incy (@increments) {
              my %condition = (
                trans => $trans,
                m => $m,
                n => $n,
                kl => int(min($m, $n) / 2),
                ku => int(min($m, $n) / 3),
                alpha => $alpha,
                incx => $incx,
                beta => $beta,
                incy => $incy,
              );
              Test::QPBLAS::run(GBMV => \%condition);
            }
          }
        }
      }
    }
  }
}
