use strict;
use warnings;

use Test::More;

require 't/common.pl';

my @uplo = Test::QPBLAS::supply_default_uplo();
my @trans = Test::QPBLAS::supply_default_trans();
my @dimensions = Test::QPBLAS::supply_default_dimensions();
my @alphabeta = Test::QPBLAS::supply_default_alphabeta();
my @increments = Test::QPBLAS::supply_default_increments();

plan tests => @uplo * @dimensions * @alphabeta * @increments * @alphabeta * @increments * 4;

for my $uplo (@uplo) {
  for my $n (@dimensions) {
    for my $alpha (@alphabeta) {
      for my $incx (@increments) {
        for my $beta (@alphabeta) {
          for my $incy (@increments) {
            my %condition = (
              uplo => $uplo,
              n => $n,
              alpha => $alpha,
              incx => $incx,
              beta => $beta,
              incy => $incy,
            );
            Test::QPBLAS::run(SYMV => \%condition);
          }
        }
      }
    }
  }
}

for my $uplo (@uplo) {
  for my $n (@dimensions) {
    for my $alpha (@alphabeta) {
      for my $incx (@increments) {
        for my $beta (@alphabeta) {
          for my $incy (@increments) {
            my %condition = (
              uplo => $uplo,
              n => $n,
              k => int($n / 2),
              alpha => $alpha,
              incx => $incx,
              beta => $beta,
              incy => $incy,
            );
            Test::QPBLAS::run(SBMV => \%condition);
          }
        }
      }
    }
  }
}

for my $uplo (@uplo) {
  for my $n (@dimensions) {
    for my $alpha (@alphabeta) {
      for my $incx (@increments) {
        for my $beta (@alphabeta) {
          for my $incy (@increments) {
            my %condition = (
              uplo => $uplo,
              n => $n,
              alpha => $alpha,
              incx => $incx,
              beta => $beta,
              incy => $incy,
            );
            Test::QPBLAS::run(HEMV => \%condition);
          }
        }
      }
    }
  }
}

for my $uplo (@uplo) {
  for my $n (@dimensions) {
    for my $alpha (@alphabeta) {
      for my $incx (@increments) {
        for my $beta (@alphabeta) {
          for my $incy (@increments) {
            my %condition = (
              uplo => $uplo,
              n => $n,
              k => int($n / 2),
              alpha => $alpha,
              incx => $incx,
              beta => $beta,
              incy => $incy,
            );
            Test::QPBLAS::run(HBMV => \%condition);
          }
        }
      }
    }
  }
}
