use strict;
use warnings;

use Test::More;

require 't/common.pl';

my @uplo = Test::QPBLAS::supply_default_uplo();
my @trans = Test::QPBLAS::supply_default_trans();
my @diag = Test::QPBLAS::supply_default_diag();
my @dimensions = Test::QPBLAS::supply_default_dimensions();
my @increments = Test::QPBLAS::supply_default_increments();

plan tests => @uplo * @trans * @diag * @dimensions * @increments * 4;

for my $uplo (@uplo) {
  for my $trans (@trans) {
    for my $diag (@diag) {
      for my $n (@dimensions) {
        for my $incx (@increments) {
          my %condition = (
            uplo => $uplo,
            trans => $trans,
            diag => $diag,
            n => $n,
            incx => $incx,
          );
          Test::QPBLAS::run(TRMV => \%condition);
        }
      }
    }
  }
}

for my $uplo (@uplo) {
  for my $trans (@trans) {
    for my $diag (@diag) {
      for my $n (@dimensions) {
        for my $incx (@increments) {
          my %condition = (
            uplo => $uplo,
            trans => $trans,
            diag => $diag,
            n => $n,
            k => int($n / 2),
            incx => $incx,
          );
          Test::QPBLAS::run(TBMV => \%condition);
        }
      }
    }
  }
}

for my $uplo (@uplo) {
  for my $trans (@trans) {
    for my $diag (@diag) {
      for my $n (@dimensions) {
        for my $incx (@increments) {
          my %condition = (
            uplo => $uplo,
            trans => $trans,
            diag => $diag,
            n => $n,
            incx => $incx,
          );
          Test::QPBLAS::run(TRSV => \%condition);
        }
      }
    }
  }
}

for my $uplo (@uplo) {
  for my $trans (@trans) {
    for my $diag (@diag) {
      for my $n (@dimensions) {
        for my $incx (@increments) {
          my %condition = (
            uplo => $uplo,
            trans => $trans,
            diag => $diag,
            n => $n,
            k => int($n / 2),
            incx => $incx,
          );
          Test::QPBLAS::run(TBSV => \%condition);
        }
      }
    }
  }
}
