use strict;
use warnings;

use Test::More;

require 't/common.pl';

my @dimensions = Test::QPBLAS::supply_default_dimensions();
my @alphabeta = Test::QPBLAS::supply_default_alphabeta();
my @increments = Test::QPBLAS::supply_default_increments();

my @routines = qw(GER GERC GERU);

my @conditions;
for my $m (@dimensions) {
  for my $n (@dimensions) {
    for my $alpha (@alphabeta) {
      for my $incx (@increments) {
        for my $incy (@increments) {
          push @conditions, {
            m => $m,
            n => $n,
            alpha => $alpha,
            incx => $incx,
            incy => $incy,
          };
        }
      }
    }
  }
}


plan tests => @routines * @conditions;

for my $routine (@routines) {
  for my $condition (@conditions) {
    Test::QPBLAS::run($routine => $condition);
  }
}
