use strict;
use warnings;

use Test::More;

require 't/common.pl';

my @uplo = Test::QPBLAS::supply_default_uplo();
my @trans = Test::QPBLAS::supply_default_trans();
my @dimensions = Test::QPBLAS::supply_default_dimensions();
my @alphabeta = Test::QPBLAS::supply_default_alphabeta();
my @increments = Test::QPBLAS::supply_default_increments();

my @routines = qw(SYR HER);

my @conditions;
for my $uplo (@uplo) {
  for my $n (@dimensions) {
    for my $alpha (@alphabeta) {
      for my $incx (@increments) {
        push @conditions, {
          uplo => $uplo,
          n => $n,
          alpha => $alpha,
          incx => $incx,
        };
      }
    }
  }
}


plan tests => @routines * @conditions;

for my $routine (@routines) {
  for my $condition (@conditions) {
    Test::QPBLAS::run($routine => $condition);
  }
}
