use strict;
use warnings;

use Test::More;

require 't/common.pl';

my @trans = Test::QPBLAS::supply_default_trans();
my @dimensions = Test::QPBLAS::supply_default_dimensions();
my @alphabeta = Test::QPBLAS::supply_default_alphabeta();

my @routines = qw(GEMM);

my @conditions;
for my $transa (@trans) {
  for my $transb (@trans) {
    for my $m (@dimensions) {
      for my $n (@dimensions) {
        for my $k (@dimensions) {
          for my $alpha (@alphabeta) {
            for my $beta (@alphabeta) {
              push @conditions, {
                transa => $transa,
                transb => $transb,
                m => $m,
                n => $n,
                k => $k,
                alpha => $alpha,
                beta => $beta,
              };
            }
          }
        }
      }
    }
  }
}


plan tests => @routines * @conditions;

for my $routine (@routines) {
  for my $condition (@conditions) {
    Test::QPBLAS::run($routine => $condition);
  }
}
