use strict;
use warnings;

use Test::More;

require 't/common.pl';

my @side = Test::QPBLAS::supply_default_side();
my @uplo = Test::QPBLAS::supply_default_uplo();
my @trans = Test::QPBLAS::supply_default_trans();
my @dimensions = Test::QPBLAS::supply_default_dimensions();
my @alphabeta = Test::QPBLAS::supply_default_alphabeta();

my @routines = qw(TRMM TRSM);

my @conditions;
for my $side (@side) {
  for my $uplo (@uplo) {
    for my $transa (@trans) {
      for my $m (@dimensions) {
        for my $n (@dimensions) {
          for my $alpha (@alphabeta) {
            push @conditions, {
              side => $side,
              uplo => $uplo,
              transa => $transa,
              m => $m,
              n => $n,
              alpha => $alpha,
            };
          }
        }
      }
    }
  }
}


plan tests => @routines * @conditions;

for my $routine (@routines) {
  for my $condition (@conditions) {
    Test::QPBLAS::run($routine => $condition);
  }
}
