use strict;
use warnings;

use Test::More;

require 't/common.pl';

my @trans = qw(n c);
my @uplo = Test::QPBLAS::supply_default_uplo();
my @dimensions = Test::QPBLAS::supply_default_dimensions();
my @alphabeta = Test::QPBLAS::supply_default_alphabeta();

my @routines = qw(HERK HER2K);

my @conditions;
for my $uplo (@uplo) {
  for my $trans (@trans) {
    for my $n (@dimensions) {
      for my $k (@dimensions) {
        for my $alpha (@alphabeta) {
          for my $beta (@alphabeta) {
            push @conditions, {
              uplo => $uplo,
              trans => $trans,
              n => $n,
              k => $k,
              alpha => $alpha,
              beta => $beta,
            };
          }
        }
      }
    }
  }
}


plan tests => @routines * @conditions;

for my $routine (@routines) {
  for my $condition (@conditions) {
    Test::QPBLAS::run($routine => $condition);
  }
}
