    PROGRAM LEVEL1

    USE LEVEL1_TESTS
    USE TEST_UTILITY
    IMPLICIT NONE

    ! increment
    INTEGER :: INCX, INCY

    ! length of vector
    INTEGER :: N

    INCX = 1
    INCY = 1
    N = 1

    CALL INIT_RANDOM_SEED()

    DO
        IF (SELECT() .EQ. 0) EXIT
    END DO
    STOP


    CONTAINS


    INTEGER FUNCTION SELECT()

    PRINT *, "QPBLAS Level 1 functions"
    !        "  ##: ####10####  ##: ####10####  ##: ####10####  ##: ####10####"
    PRINT *, "   1: ddswap       2: ddscal       3: ddcopy       4: ddaxpy"
    PRINT *, "   5: dddot        6: ddnrm2       7: ddasum       8: iddamax"
    PRINT *, "   9: ddrot       10: ddrotg      11: ddrotm      12: ddrotmg"
    PRINT *, "  13: zzdotc      14: zzdotu"
    PRINT *, ""
    PRINT *, "  70: INCX        71: INCY                        75: N"
    PRINT *, "  96: TEST_ALL    97: VERBOSE     98: VERIFY      99: BENCHMARK"
    PRINT *, "   0: EXIT"

    DO
        WRITE (*,fmt='(a)', advance='no') "Please select the number of function to test: "
        READ *, SELECT
        IF (SELECT .GE. 0 .AND. SELECT .LE. 14) THEN
            EXIT
        ELSE IF (SELECT .EQ. 70) THEN
            CALL CHANGE_INTEGER("INCX", INCX)
        ELSE IF (SELECT .EQ. 71) THEN
            CALL CHANGE_INTEGER("INCY", INCY)
        ELSE IF (SELECT .EQ. 75) THEN
            CALL CHANGE_INTEGER("N", N)
        ELSE IF (SELECT .EQ. 96) THEN
            EXIT
        ELSE IF (SELECT .EQ. 97) THEN
            CALL TOGGLE_MODE_VERBOSE()
        ELSE IF (SELECT .EQ. 98) THEN
            CALL TOGGLE_MODE_VERIFY()
        ELSE IF (SELECT .EQ. 99) THEN
            CALL TOGGLE_MODE_BENCHMARK()
        END IF
    END DO

    IF (SELECT .EQ. 0) THEN
        ! noop
    ELSE IF (SELECT .EQ. 1) THEN
        CALL DDSWAP_TEST(N, INCX, INCY)
    ELSE IF (SELECT .EQ. 2) THEN
        CALL DDSCAL_TEST(N, INCX)
    ELSE IF (SELECT .EQ. 3) THEN
        CALL DDCOPY_TEST(N, INCX, INCY)
    ELSE IF (SELECT .EQ. 4) THEN
        CALL DDAXPY_TEST(N, INCX, INCY)
    ELSE IF (SELECT .EQ. 5) THEN
        CALL DDDOT_TEST(N, INCX, INCY)
    ELSE IF (SELECT .EQ. 6) THEN
        CALL DDNRM2_TEST(N, INCX)
    ELSE IF (SELECT .EQ. 7) THEN
        CALL DDASUM_TEST(N, INCX)
    ELSE IF (SELECT .EQ. 8) THEN
        CALL IDDAMAX_TEST(N, INCX)
    ELSE IF (SELECT .EQ. 9) THEN
        CALL DDROT_TEST(N, INCX, INCY)
    ELSE IF (SELECT .EQ. 10) THEN
        CALL DDROTG_TEST()
    ELSE IF (SELECT .EQ. 11) THEN
        CALL DDROTM_TEST(N, INCX, INCY)
    ELSE IF (SELECT .EQ. 12) THEN
        CALL DDROTMG_TEST()
    ELSE IF (SELECT .EQ. 13) THEN
        CALL ZZDOTC_TEST(N, INCX, INCY)
    ELSE IF (SELECT .EQ. 14) THEN
        CALL ZZDOTU_TEST(N, INCX, INCY)
    ELSE IF (SELECT .EQ. 96) THEN
        PRINT *, "-----"
        CALL DDSWAP_TEST(N, INCX, INCY)
        PRINT *, "-----"
        CALL DDSCAL_TEST(N, INCX)
        PRINT *, "-----"
        CALL DDCOPY_TEST(N, INCX, INCY)
        PRINT *, "-----"
        CALL DDAXPY_TEST(N, INCX, INCY)
        PRINT *, "-----"
        CALL DDDOT_TEST(N, INCX, INCY)
        PRINT *, "-----"
        CALL DDNRM2_TEST(N, INCX)
        PRINT *, "-----"
        CALL DDASUM_TEST(N, INCX)
        PRINT *, "-----"
        CALL IDDAMAX_TEST(N, INCX)
        PRINT *, "-----"
        CALL DDROT_TEST(N, INCX, INCY)
        PRINT *, "-----"
        CALL DDROTG_TEST()
        PRINT *, "-----"
        CALL DDROTM_TEST(N, INCX, INCY)
        PRINT *, "-----"
        CALL DDROTMG_TEST()
        PRINT *, "-----"
        CALL ZZDOTC_TEST(N, INCX, INCY)
        PRINT *, "-----"
        CALL ZZDOTU_TEST(N, INCX, INCY)
        PRINT *, "-----"
    ELSE
        PRINT *, "INTERNAL ERROR"
    END IF
    PRINT *, ""
    PRINT *, ""

    END FUNCTION


    END PROGRAM
