    PROGRAM LEVEL3

    USE LEVEL3_TESTS
    USE TEST_UTILITY
    IMPLICIT NONE

    ! size of matrix
    INTEGER :: M, N, K

    ! style of matrix
    CHARACTER(1) :: UPLO, DIAG, SIDE, TRANSA, TRANSB

    M = 6
    N = 5
    K = 4

    UPLO = 'U'
    DIAG = 'N'
    SIDE = 'L'
    TRANSA = 'N'
    TRANSB = 'N'

    CALL INIT_RANDOM_SEED()

    DO
        IF (SELECT() .EQ. 0) EXIT
    END DO
    STOP


    CONTAINS


    INTEGER FUNCTION SELECT()

    PRINT *, "QPBLAS Level 3 functions"
    !        "  ##: ####10####  ##: ####10####  ##: ####10####  ##: ####10####"
    PRINT *, "   1: ddgemm       2: ddsymm       3: ddsyr2k      4: ddsyrk"
    PRINT *, "   5: ddtrmm       6: ddtrsm       7: zzhemm       8: zzher2k"
    PRINT *, "   9: zzherk"
    PRINT *, ""
    PRINT *, "  72: ALPHA       73: BETA"
    PRINT *, "  74: M           75: N           76: K"
    PRINT *, "  80: UPLO        81: DIAG        82: SIDE"
    PRINT *, "  83: TRANS[A]    84: TRANSB"
    PRINT *, "  96: TEST_ALL    97: VERBOSE     98: VERIFY      99: BENCHMARK"
    PRINT *, "   0: EXIT"

    DO
        WRITE (*,fmt='(a)', advance='no') "Please select the number of function to test: "
        READ *, SELECT
        IF (SELECT .GE. 0 .AND. SELECT .LE. 9) THEN
            EXIT
        ELSE IF (SELECT .EQ. 72) THEN
            CALL CHANGE_INTEGER("ALPHA", FIXED_ALPHA)
        ELSE IF (SELECT .EQ. 73) THEN
            CALL CHANGE_INTEGER("BETA", FIXED_BETA)
        ELSE IF (SELECT .EQ. 74) THEN
            CALL CHANGE_INTEGER("M", M)
        ELSE IF (SELECT .EQ. 75) THEN
            CALL CHANGE_INTEGER("N", N)
        ELSE IF (SELECT .EQ. 76) THEN
            CALL CHANGE_INTEGER("K", K)
        ELSE IF (SELECT .EQ. 80) THEN
            CALL CHANGE_CHARACTER("UPLO", UPLO)
        ELSE IF (SELECT .EQ. 81) THEN
            CALL CHANGE_CHARACTER("DIAG", DIAG)
        ELSE IF (SELECT .EQ. 82) THEN
            CALL CHANGE_CHARACTER("SIDE", SIDE)
        ELSE IF (SELECT .EQ. 83) THEN
            CALL CHANGE_CHARACTER("TRANS[A]", TRANSA)
        ELSE IF (SELECT .EQ. 84) THEN
            CALL CHANGE_CHARACTER("TRANSB", TRANSB)
        ELSE IF (SELECT .EQ. 96) THEN
            EXIT
        ELSE IF (SELECT .EQ. 97) THEN
            CALL TOGGLE_MODE_VERBOSE()
        ELSE IF (SELECT .EQ. 98) THEN
            CALL TOGGLE_MODE_VERIFY()
        ELSE IF (SELECT .EQ. 99) THEN
            CALL TOGGLE_MODE_BENCHMARK()
        END IF
    END DO

    IF (SELECT .EQ. 0) THEN
        ! noop
    ELSE IF (SELECT .EQ. 1) THEN
        CALL DDGEMM_TEST(TRANSA, TRANSB, M, N, K)
    ELSE IF (SELECT .EQ. 2) THEN
        CALL DDSYMM_TEST(SIDE, UPLO, M, N)
    ELSE IF (SELECT .EQ. 3) THEN
        CALL DDSYR2K_TEST(UPLO, TRANSA, N, K)
    ELSE IF (SELECT .EQ. 4) THEN
        CALL DDSYRK_TEST(UPLO, TRANSA, N, K)
    ELSE IF (SELECT .EQ. 5) THEN
        CALL DDTRMM_TEST(SIDE, UPLO, TRANSA, DIAG, M, N)
    ELSE IF (SELECT .EQ. 6) THEN
        CALL DDTRSM_TEST(SIDE, UPLO, TRANSA, DIAG, M, N)
    ELSE IF (SELECT .EQ. 7) THEN
        CALL ZZHEMM_TEST(SIDE, UPLO, M, N)
    ELSE IF (SELECT .EQ. 8) THEN
        CALL ZZHER2K_TEST(UPLO, TRANSA, N, K)
    ELSE IF (SELECT .EQ. 9) THEN
        CALL ZZHERK_TEST(UPLO, TRANSA, N, K)
    ELSE IF (SELECT .EQ. 96) THEN
        PRINT *, "-----"
        CALL DDGEMM_TEST(TRANSA, TRANSB, M, N, K)
        PRINT *, "-----"
        CALL DDSYMM_TEST(SIDE, UPLO, M, N)
        PRINT *, "-----"
        CALL DDSYR2K_TEST(UPLO, TRANSA, N, K)
        PRINT *, "-----"
        CALL DDSYRK_TEST(UPLO, TRANSA, N, K)
        PRINT *, "-----"
        CALL DDTRMM_TEST(SIDE, UPLO, TRANSA, DIAG, M, N)
        PRINT *, "-----"
        CALL DDTRSM_TEST(SIDE, UPLO, TRANSA, DIAG, M, N)
        PRINT *, "-----"
        CALL ZZHEMM_TEST(SIDE, UPLO, M, N)
        PRINT *, "-----"
        CALL ZZHER2K_TEST(UPLO, TRANSA, N, K)
        PRINT *, "-----"
        CALL ZZHERK_TEST(UPLO, TRANSA, N, K)
        PRINT *, "-----"
    ELSE
        PRINT *, "INTERNAL ERROR"
    END IF
    PRINT *, ""

    END FUNCTION


    END PROGRAM
